/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\file oess_1/tlv/h/tagged_scalar_wrapper.hpp
	\brief Класс %oess_1::tlv::tagged_scalar_wrapper_t.
*/

#if !defined( _OESS_1__TLV__TAGGED_SCALAR_WRAPPER_HPP_ )
#define _OESS_1__TLV__TAGGED_SCALAR_WRAPPER_HPP_

#include <oess_1/tlv/h/declspec.hpp>

#include <string>

#include <oess_1/tlv/h/base.hpp>
#include <oess_1/tlv/h/default_processors.hpp>
#include <oess_1/tlv/h/errno.hpp>

namespace oess_1
{

namespace tlv
{

//
// tagged_scalar_wrapper_t
//

//! TLV для сериализации одиночных объектов примитивных типов
//! с определенным значением Tag.
/*!
//FIX ME: обосновать!
	\par Требования к типу Serializer:
	- должен быть определен тип Serializer::value_type_t;
	- должен быть конструктор, получающий значение поля Tag:
\code
Serializer::Serializer( tag_value );
\endcode.
В качестве значения tag_value в конструктор Serializer
передается значение типа oess_1::tlv::default_tag_type_t;
	- должен быть конструктор, получающий значение полей
Tag и Value:
\code
Serializer::Serializer( tag_value,
	const value_type_t & value );
\endcode.
В качестве значения tag_value в конструктор Serializer
передается значение типа oess_1::tlv::default_tag_type_t;
	- должен существовать конструктор и оператор копирования:
\code
Serializer::Serializer( const Serializer & o );
Serializer &
Serializer::operator=( const Serializer & o );
\endcode
	- должен существовать метод:
\code
const value_type_t &
Serializer::query_value() const;
\endcode
	- должен существовать метод:
\code
void
Serializer::set_value( const value_type_t & value );
\endcode
*/
template< default_tag_type_t Tag_value,
	class Serializer >
class	tagged_scalar_wrapper_t :
	public tlv_base_t
{
	public :
		//! Псевдоним для типа поля Value.
		typedef typename Serializer::value_type_t
			value_type_t;

		//! Синоним для tagged_scalar_wrapper_t< Tag_value,
		//! Serializer >.
		typedef tagged_scalar_wrapper_t< Tag_value,
				Serializer >
			self_t;

	private :
		//! Реальный обработчик TLV.
		Serializer	m_tlv;

	public :
		//! Конструктор по умолчанию.
		tagged_scalar_wrapper_t()
			:
				m_tlv( Tag_value )
		{
		}

		//! Назначение значения полю Value.
		tagged_scalar_wrapper_t(
			const value_type_t & value )
			:
				m_tlv( Tag_value, value )
		{
		}

		//! Конструктор копирования.
		tagged_scalar_wrapper_t(
			const self_t & o )
			:
				m_tlv( o.m_tlv )
		{
		}

		virtual ~tagged_scalar_wrapper_t()
		{
		}

		//! Оператор копирования.
		self_t &
		operator=( const self_t & o )
		{
			if( &o != this )
			{
				m_tlv = o.m_tlv;
			}
			return *this;
		}

		//! Получить текущее значение поля Value.
		const value_type_t &
		query_value() const
		{
			return m_tlv.query_value();
		}

		//! Установить значение поля Value.
		void
		set_value(
			//! Новое значение для поля Value.
			const value_type_t & value )
		{
			m_tlv.set_value( value );
		}

		//! Получить значение поля Tag.
		virtual default_tag_type_t
		tlv_tag() const
		{
			return Tag_value;
		}

		//! Количество байт, которые требуются
		//! для представления всего TLV (с учетом Tag, Length,
		//! Value).
		virtual size_t
		tlv_size() const
		{
			return m_tlv.tlv_size();
		}

		//! Извлечение полей Length и Value из входного потока.
		/*!
			\throw std::exception При возникновении ошибок.
		*/
		virtual void
		tlv_unpack(
			//! Поток, с текущей позиции которого будет
			//! осуществляться чтение полей Length и Value.
			oess_1::io::ibinstream_t & s,
			//! В данном классе игнорируется
			default_tag_type_t t)
		{
			m_tlv.tlv_unpack( s, t );
		}

		//! Запись TLV в выходной поток.
		virtual void
		tlv_pack(
			//! Поток, с текущей позиции которого будет
			//! осуществляться запись TLV.
			oess_1::io::obinstream_t & s ) const
		{
			m_tlv.tlv_pack( s );
		}
};

} /* namespace tlv */

} /* namespace oess_1 */

#endif

